' QMPwrClient.inc
' QMClient API function and constant definitions.
' Copyright (c) 2002, Ladybridge Systems, All Rights Reserved
' Modified for Power Basic compilers by Don Montaine with
' remaining qmClient functions added Apr 2008
' Alias required for all Declares as PB assumes all upper case w/o it
' Continuation character used because PB limited to 256 char line length

DECLARE SUB QMCall LIB "QMClient.dll" ALIAS "QMCall"_
   (BYVAL qmName   AS STRING,_
    BYVAL ArgCount AS INTEGER,_
    OPT BYREF a1   AS STRING,_
    OPT BYREF a2   AS STRING,_
    OPT BYREF a3   AS STRING,_
    OPT BYREF a4   AS STRING,_
    OPT BYREF a5   AS STRING,_
    OPT BYREF a6   AS STRING,_
    OPT BYREF a7   AS STRING,_
    OPT BYREF a8   AS STRING,_
    OPT BYREF a9   AS STRING,_
    OPT BYREF a10  AS STRING,_
    OPT BYREF a11  AS STRING,_
    OPT BYREF a12  AS STRING,_
    OPT BYREF a13  AS STRING,_
    OPT BYREF a14  AS STRING,_
    OPT BYREF a15  AS STRING,_
    OPT BYREF a16  AS STRING,_
    OPT BYREF a17  AS STRING,_
    OPT BYREF a18  AS STRING,_
    OPT BYREF a19  AS STRING,_
    OPT BYREF a20  AS STRING)

DECLARE FUNCTION QMChange LIB "QMClient.dll" ALIAS "QMChange"_
   (BYVAL     Str         AS STRING,_
    BYVAL     OldStr      AS STRING,_
    BYVAL     NewStr      AS STRING,_
    OPT BYREF Occurrences AS LONG,_
    OPT BYREF Start       AS LONG) AS STRING

DECLARE FUNCTION QMChecksum LIB "QMClient.dll" ALIAS "QMChecksum"_
   (BYVAL     Str         AS STRING) AS INTEGER

DECLARE SUB QMClearSelect LIB "QMClient.dll" ALIAS "QMClearSelect"_
   (BYVAL ListNo AS INTEGER)

DECLARE SUB QMClose LIB "QMClient.dll" ALIAS "QMClose"_
   (BYVAL FileNo AS INTEGER)

DECLARE FUNCTION QMConnect LIB "QMClient.dll" ALIAS "QMConnect"_
   (BYVAL qmHost   AS STRING,_
    BYVAL qmPort   AS INTEGER,_
    BYVAL UserName AS STRING,_
    BYVAL Password AS STRING,_
    BYVAL Account  AS STRING) AS BYTE

DECLARE FUNCTION QMConnected LIB "QMClient.dll" ALIAS "QMConnected"_
   () AS BYTE

DECLARE SUB QMConnectionType LIB "QMClient.dll" ALIAS "QMConnectionType"_
   (BYVAL Type AS INTEGER)

DECLARE FUNCTION QMConnectLocal LIB "QMConnectLocal" ALIAS
"QMConnectLocal"_
   (BYVAL Account  AS STRING) AS BYTE

DECLARE FUNCTION QMDcount LIB "QMClient.dll" ALIAS "QMDcount"_
   (BYVAL Src   AS STRING,_
    BYVAL Delim AS STRING) AS LONG

DECLARE SUB QMDebug LIB "QMClient.dll" ALIAS "QMDebug"_
   (BYVAL State AS BYTE)

DECLARE FUNCTION QMDecrypt LIB "QMClient.dll" ALIAS "QMDecrypt"_
   (BYVAL Data AS STRING,_
    BYVAL Key  AS STRING) AS STRING

DECLARE FUNCTION QMDel LIB "QMClient.dll" ALIAS "QMDel"_
   (BYVAL Src  AS STRING,_
    BYVAL Fno  AS INTEGER,_
    BYVAL Vno  AS INTEGER,_
    BYVAL Svno AS INTEGER) AS STRING

DECLARE SUB QMDelete LIB "QMClient.dll" ALIAS "QMDelete"_
   (BYVAL FileNo AS INTEGER,_
    BYVAL Id     AS STRING)

DECLARE SUB QMDeleteu LIB "QMClient.dll" ALIAS "QMDeleteu"_
   (BYVAL FileNo AS INTEGER,_
    BYVAL Id     AS STRING)

DECLARE SUB QMDisconnect LIB "QMClient.dll" ALIAS "QMDisconnect" ()

DECLARE SUB QMDisconnectAll LIB "QMClient.dll" ALIAS "QMDisconnectAll" ()

DECLARE FUNCTION QMEncrypt LIB "QMClient.dll" ALIAS "QMEncrypt"_
   (BYVAL Data AS STRING,_
    BYVAL Key  AS STRING) AS STRING

DECLARE SUB QMEndCommand LIB "QMClient.dll" ALIAS "QMEndCommand" ()

DECLARE FUNCTION QMError LIB "QMClient.dll" ALIAS "QMError" () AS STRING

DECLARE FUNCTION QMExecute LIB "QMClient.dll" ALIAS "QMExecute"_
  (BYVAL Cmnd  AS STRING,_
   BYREF ErrNo AS INTEGER) AS STRING

DECLARE FUNCTION QMExtract LIB "QMClient.dll" ALIAS "QMExtract"_
  (BYVAL     Str         AS STRING,_
   BYVAL     Delimited   AS STRING,_
   BYVAL     Start       AS LONG,_
   OPT BYREF Occurrences AS LONG) AS STRING

DECLARE FUNCTION QMField LIB "QMClient.dll" ALIAS "QMField"_
   (BYVAL     Src         AS STRING,_
    BYVAL     Delimiter   AS STRING,_
    BYVAL     Start       AS LONG,_
    OPT BYREF Occurrences AS LONG) AS STRING

DECLARE FUNCTION QMGetSession LIB "QMClient.dll" ALIAS "QMGetSession" ()_
   AS INTEGER

DECLARE FUNCTION QMGetVar LIB "QMClient.dll" ALIAS "QMGetVar"_
  (BYVAL Name   AS STRING) AS STRING

DECLARE FUNCTION QMIns LIB "QMClient.dll" ALIAS "QMIns" _
  (BYVAL Src     AS STRING,_
   BYVAL Fno     AS INTEGER,_
   BYVAL Vno     AS INTEGER,_
   BYVAL Svno    AS INTEGER,_
   BYVAL NewData AS STRING) AS STRING

DECLARE FUNCTION QMLocate LIB "QMClient.dll" ALIAS "QMLocate"_
  (BYVAL Item  AS STRING,_
   BYVAL Src   AS STRING,_
   BYVAL Fno   AS INTEGER,_
   BYVAL Vno   AS INTEGER,_
   BYVAL Svno  AS INTEGER,_
   BYREF POS   AS INTEGER,_
   BYVAL Order AS STRING) AS BYTE

DECLARE FUNCTION QMLogto LIB "QMClient.dll" ALIAS "QMLogto"_
  (BYVAL Account AS STRING) AS BYTE

DECLARE SUB QMMarkMapping LIB "QMClient.dll" ALIAS "QMMarkMapping"_
  (BYVAL FileNo AS INTEGER,_
   BYVAL State  AS INTEGER)

DECLARE FUNCTION QMMatch LIB "QMClient.dll" ALIAS "QMMatch"_
  (BYVAL Src       AS STRING,_
   BYVAL Template  AS STRING) AS BYTE

DECLARE FUNCTION QMMatchfield LIB "QMClient.dll" ALIAS "QMMatchfield"_
  (BYVAL Src       AS STRING,_
   BYVAL Template  AS STRING,_
   BYVAL Component AS INTEGER) AS STRING

DECLARE FUNCTION QMNextPartial LIB "QMClient.dll" ALIAS "QMNextPartial"_
  (BYVAL ListNo AS INTEGER) AS STRING

DECLARE FUNCTION QMOpen LIB "QMClient.dll" ALIAS "QMOpen"_
  (BYVAL Filename AS STRING) AS INTEGER

DECLARE FUNCTION QMRead LIB "QMClient.dll" ALIAS "QMRead"_
  (BYVAL FileNo AS INTEGER,_
   BYVAL Id     AS STRING,_
   BYREF ErrNo  AS INTEGER) AS STRING

DECLARE FUNCTION QMReadl LIB "QMClient.dll" ALIAS "QMReadl"_
  (BYVAL FileNo AS INTEGER,_
   BYVAL Id     AS STRING,_
   BYVAL Wait   AS BYTE,_
   BYREF ErrNo  AS INTEGER) AS STRING

DECLARE FUNCTION QMReadList LIB "QMClient.dll" ALIAS "QMReadList"_
  (BYVAL ListNo AS INTEGER,_
   BYREF ErrNo  AS INTEGER) AS STRING

DECLARE FUNCTION QMReadNext LIB "QMClient.dll" ALIAS "QMReadNext"_
  (BYVAL ListNo AS INTEGER,_
   BYREF ErrNo  AS INTEGER) AS STRING

DECLARE FUNCTION QMReadu LIB "QMClient.dll" ALIAS "QMReadu"_
  (BYVAL FileNo AS INTEGER,_
   BYVAL Id     AS STRING,_
   BYVAL Wait   AS BYTE,_
   BYREF ErrNo  AS INTEGER) AS STRING

DECLARE SUB QMRecordlock LIB "QMClient.dll" ALIAS "QMRecordLock"_
   (BYVAL FileNo AS INTEGER,_
    BYVAL Id     AS STRING,_
    BYVAL Update AS INTEGER,_
    BYVAL Wait AS INTEGER)

DECLARE SUB QMRecordlocked LIB "QMClient.dll" ALIAS "QMRecordLocked"_
   (BYVAL FileNo AS INTEGER,_
    BYVAL Id     AS STRING) AS INTEGER

DECLARE SUB QMRelease LIB "QMClient.dll" ALIAS "QMRelease"_
  (BYVAL FileNo AS INTEGER,_
   BYVAL Id     AS STRING)

DECLARE FUNCTION QMReplace LIB "QMClient.dll" ALIAS "QMReplace"_
  (BYVAL Src     AS STRING,_
   BYVAL Fno     AS INTEGER,_
   BYVAL Vno     AS INTEGER,_
   BYVAL Svno    AS INTEGER,_
   BYVAL NewData AS STRING) AS STRING

DECLARE FUNCTION QMRespond LIB "QMClient.dll" ALIAS "QMRespond"_
  (BYVAL Response AS STRING,_
   BYREF ErrNo    AS INTEGER) AS STRING

DECLARE FUNCTION QMRevision LIB "QMClient.dll" ALIAS "QMRevision" () AS STRING

DECLARE SUB QMSelect LIB "QMClient.dll" ALIAS "QMSelect"_
  (BYVAL FileNo AS INTEGER,_
   BYVAL ListNo AS INTEGER)

DECLARE SUB QMSelectIndex LIB "QMClient.dll" ALIAS "QMSelectIndex"_
  (BYVAL FileNo     AS INTEGER,_
   BYVAL IndexName  AS STRING,_
   BYVAL IndexValue AS STRING,_
   BYVAL ListNo     AS INTEGER)

DECLARE SUB QMSelectLeft LIB "QMClient.dll" ALIAS "QMSelectLeft"_
  (BYVAL FileNo     AS INTEGER,_
   BYVAL IndexName  AS STRING,_
   BYVAL ListNo     AS INTEGER)

DECLARE SUB QMSelectRight LIB "QMClient.dll" ALIAS "QMSelectRight"_
  (BYVAL FileNo     AS INTEGER,_
   BYVAL IndexName  AS STRING,_
   BYVAL ListNo     AS INTEGER)

DECLARE SUB QMSetLeft LIB "QMClient.dll" ALIAS "QMSetLeft"_
  (BYVAL FileNo     AS INTEGER,_
   BYVAL IndexName  AS STRING)

DECLARE FUNCTION QMSelectPartial LIB "QMClient.dll" ALIAS "QMSelectPartial"_
  (BYVAL FileNo AS INTEGER,_
   BYVAL ListNo AS INTEGER) AS STRING

DECLARE SUB QMSetRight LIB "QMClient.dll" ALIAS "QMSetRight"_
  (BYVAL FileNo     AS INTEGER,_
   BYVAL IndexName  AS STRING)

DECLARE FUNCTION QMSetSession LIB "QMClient.dll" ALIAS "QMSetSession"_
   (BYREF Session AS INTEGER) AS BYTE

DECLARE FUNCTION QMStatus LIB "QMClient.dll" ALIAS "QMStatus"_
  () AS LONG

DECLARE SUB QMTrapCallAbort LIB "QMClient.dll" ALIAS "QMTrapCallAbort"_
   (BYVAL Mode AS BYTE)

DECLARE SUB QMWrite LIB "QMClient.dll" ALIAS "QMWrite"_
  (BYVAL FileNo AS INTEGER,_
   BYVAL Id     AS STRING,_
   BYVAL qmData AS STRING)

DECLARE SUB QMWriteu LIB "QMClient.dll" ALIAS "QMWriteu"_
  (BYVAL FileNo AS INTEGER,_
   BYVAL Id     AS STRING,_
   BYVAL qmData AS STRING)

%SV_OK = 0        ' Action successul
%SV_ON_ERROR = 1  ' Trapped abort
%SV_ELSE = 2      ' Action took the ELSE clause
%SV_ERROR = 3     ' Error for which QMError() can be used to retrieve error text
%SV_LOCKED = 4    ' Action blocked by a lock held by another user
%SV_PROMPT = 5    ' Server requesting input


